# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'DocumentRawDocumentFileType',
    'GoogleCloudContentwarehouseV1AccessControlActionOperationType',
    'GoogleCloudContentwarehouseV1RuleTriggerType',
    'GoogleCloudContentwarehouseV1UpdateOptionsUpdateType',
    'GoogleCloudDocumentaiV1DocumentPageAnchorPageRefLayoutType',
    'GoogleCloudDocumentaiV1DocumentPageLayoutOrientation',
    'GoogleCloudDocumentaiV1DocumentPageTokenDetectedBreakType',
    'GoogleCloudDocumentaiV1DocumentProvenanceType',
    'GoogleIamV1AuditLogConfigLogType',
]


class DocumentRawDocumentFileType(str, Enum):
    """
    This is used when DocAI was not used to load the document and parsing/ extracting is needed for the inline_raw_document. For example, if inline_raw_document is the byte representation of a PDF file, then this should be set to: RAW_DOCUMENT_FILE_TYPE_PDF.
    """
    RAW_DOCUMENT_FILE_TYPE_UNSPECIFIED = "RAW_DOCUMENT_FILE_TYPE_UNSPECIFIED"
    """
    No raw document specified or it is non-parsable
    """
    RAW_DOCUMENT_FILE_TYPE_PDF = "RAW_DOCUMENT_FILE_TYPE_PDF"
    """
    Adobe PDF format
    """
    RAW_DOCUMENT_FILE_TYPE_DOCX = "RAW_DOCUMENT_FILE_TYPE_DOCX"
    """
    Microsoft Word format
    """
    RAW_DOCUMENT_FILE_TYPE_XLSX = "RAW_DOCUMENT_FILE_TYPE_XLSX"
    """
    Microsoft Excel format
    """
    RAW_DOCUMENT_FILE_TYPE_PPTX = "RAW_DOCUMENT_FILE_TYPE_PPTX"
    """
    Microsoft Powerpoint format
    """
    RAW_DOCUMENT_FILE_TYPE_TEXT = "RAW_DOCUMENT_FILE_TYPE_TEXT"
    """
    UTF-8 encoded text format
    """


class GoogleCloudContentwarehouseV1AccessControlActionOperationType(str, Enum):
    """
    Identifies the type of operation.
    """
    UNKNOWN = "UNKNOWN"
    ADD_POLICY_BINDING = "ADD_POLICY_BINDING"
    """
    Adds newly given policy bindings in the existing bindings list.
    """
    REMOVE_POLICY_BINDING = "REMOVE_POLICY_BINDING"
    """
    Removes newly given policy bindings from the existing bindings list.
    """
    REPLACE_POLICY_BINDING = "REPLACE_POLICY_BINDING"
    """
    Replaces existing policy bindings with the given policy binding list
    """


class GoogleCloudContentwarehouseV1RuleTriggerType(str, Enum):
    """
    Identifies the trigger type for running the policy.
    """
    UNKNOWN = "UNKNOWN"
    ON_CREATE = "ON_CREATE"
    """
    Trigger for create document action.
    """
    ON_UPDATE = "ON_UPDATE"
    """
    Trigger for update document action.
    """


class GoogleCloudContentwarehouseV1UpdateOptionsUpdateType(str, Enum):
    """
    Type for update.
    """
    UPDATE_TYPE_UNSPECIFIED = "UPDATE_TYPE_UNSPECIFIED"
    """
    Defaults to full replace behavior, ie. FULL_REPLACE.
    """
    UPDATE_TYPE_REPLACE = "UPDATE_TYPE_REPLACE"
    """
    Fully replace all the fields. Any field masks will be ignored.
    """
    UPDATE_TYPE_MERGE = "UPDATE_TYPE_MERGE"
    """
    Merge the fields into the existing entities.
    """
    UPDATE_TYPE_INSERT_PROPERTIES_BY_NAMES = "UPDATE_TYPE_INSERT_PROPERTIES_BY_NAMES"
    """
    Inserts the properties by names.
    """
    UPDATE_TYPE_REPLACE_PROPERTIES_BY_NAMES = "UPDATE_TYPE_REPLACE_PROPERTIES_BY_NAMES"
    """
    Replace the properties by names.
    """
    UPDATE_TYPE_DELETE_PROPERTIES_BY_NAMES = "UPDATE_TYPE_DELETE_PROPERTIES_BY_NAMES"
    """
    Delete the properties by names.
    """


class GoogleCloudDocumentaiV1DocumentPageAnchorPageRefLayoutType(str, Enum):
    """
    Optional. The type of the layout element that is being referenced if any.
    """
    LAYOUT_TYPE_UNSPECIFIED = "LAYOUT_TYPE_UNSPECIFIED"
    """
    Layout Unspecified.
    """
    BLOCK = "BLOCK"
    """
    References a Page.blocks element.
    """
    PARAGRAPH = "PARAGRAPH"
    """
    References a Page.paragraphs element.
    """
    LINE = "LINE"
    """
    References a Page.lines element.
    """
    TOKEN = "TOKEN"
    """
    References a Page.tokens element.
    """
    VISUAL_ELEMENT = "VISUAL_ELEMENT"
    """
    References a Page.visual_elements element.
    """
    TABLE = "TABLE"
    """
    Refrrences a Page.tables element.
    """
    FORM_FIELD = "FORM_FIELD"
    """
    References a Page.form_fields element.
    """


class GoogleCloudDocumentaiV1DocumentPageLayoutOrientation(str, Enum):
    """
    Detected orientation for the Layout.
    """
    ORIENTATION_UNSPECIFIED = "ORIENTATION_UNSPECIFIED"
    """
    Unspecified orientation.
    """
    PAGE_UP = "PAGE_UP"
    """
    Orientation is aligned with page up.
    """
    PAGE_RIGHT = "PAGE_RIGHT"
    """
    Orientation is aligned with page right. Turn the head 90 degrees clockwise from upright to read.
    """
    PAGE_DOWN = "PAGE_DOWN"
    """
    Orientation is aligned with page down. Turn the head 180 degrees from upright to read.
    """
    PAGE_LEFT = "PAGE_LEFT"
    """
    Orientation is aligned with page left. Turn the head 90 degrees counterclockwise from upright to read.
    """


class GoogleCloudDocumentaiV1DocumentPageTokenDetectedBreakType(str, Enum):
    """
    Detected break type.
    """
    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    """
    Unspecified break type.
    """
    SPACE = "SPACE"
    """
    A single whitespace.
    """
    WIDE_SPACE = "WIDE_SPACE"
    """
    A wider whitespace.
    """
    HYPHEN = "HYPHEN"
    """
    A hyphen that indicates that a token has been split across lines.
    """


class GoogleCloudDocumentaiV1DocumentProvenanceType(str, Enum):
    """
    The type of provenance operation.
    """
    OPERATION_TYPE_UNSPECIFIED = "OPERATION_TYPE_UNSPECIFIED"
    """
    Operation type unspecified. If no operation is specified a provenance entry is simply used to match against a `parent`.
    """
    ADD = "ADD"
    """
    Add an element.
    """
    REMOVE = "REMOVE"
    """
    Remove an element identified by `parent`.
    """
    REPLACE = "REPLACE"
    """
    Replace an element identified by `parent`.
    """
    EVAL_REQUESTED = "EVAL_REQUESTED"
    """
    Request human review for the element identified by `parent`.
    """
    EVAL_APPROVED = "EVAL_APPROVED"
    """
    Element is reviewed and approved at human review, confidence will be set to 1.0.
    """
    EVAL_SKIPPED = "EVAL_SKIPPED"
    """
    Element is skipped in the validation process.
    """


class GoogleIamV1AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """
