# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AuditLogConfigLogType',
    'InternalRangeOverlapsItem',
    'InternalRangePeering',
    'InternalRangeUsage',
]


class AuditLogConfigLogType(str, Enum):
    """
    The log type that this config enables.
    """
    LOG_TYPE_UNSPECIFIED = "LOG_TYPE_UNSPECIFIED"
    """
    Default case. Should never be this.
    """
    ADMIN_READ = "ADMIN_READ"
    """
    Admin reads. Example: CloudIAM getIamPolicy
    """
    DATA_WRITE = "DATA_WRITE"
    """
    Data writes. Example: CloudSQL Users create
    """
    DATA_READ = "DATA_READ"
    """
    Data reads. Example: CloudSQL Users list
    """


class InternalRangeOverlapsItem(str, Enum):
    OVERLAP_UNSPECIFIED = "OVERLAP_UNSPECIFIED"
    """
    No overlap overrides.
    """
    OVERLAP_ROUTE_RANGE = "OVERLAP_ROUTE_RANGE"
    """
    Allow creation of static routes more specific that the current InternalRange.
    """


class InternalRangePeering(str, Enum):
    """
    The type of peering set for this InternalRange.
    """
    PEERING_UNSPECIFIED = "PEERING_UNSPECIFIED"
    """
    If Peering is left unspecified in CreateInternalRange or UpdateInternalRange, it will be defaulted to FOR_SELF.
    """
    FOR_SELF = "FOR_SELF"
    """
    This is the default behavior and represents the case that this InternalRange is intended to be used in the VPC on which it is created and is accessible from it’s peers. This implies that peers or peer-of-peer’s cannot use this range.
    """
    FOR_PEER = "FOR_PEER"
    """
    This behavior can be set when the Internal Range is being reserved for usage by the peers. This means that no resource within the VPC in which it is being created can use this to associate with a GCP resource, but one of the peer’s can. This represents "donating" a range for peers to use.
    """
    NOT_SHARED = "NOT_SHARED"
    """
    This behavior can be set when the Internal Range is being reserved for usage by the VPC on which it is created but not shared with the peers. In a sense it is local to the VPC. This can be used to create Internal Ranges for various purposes like HTTP_INTERNAL_LOAD_BALANCER or for interconnect routes that are not shared with peers. This also implies that peer’s cannot use this range in a way that is visible to this VPC, but can re-use this range as long as it is NOT_SHARED from the peer VPC too.
    """


class InternalRangeUsage(str, Enum):
    """
    The type of usage set for this InternalRange.
    """
    USAGE_UNSPECIFIED = "USAGE_UNSPECIFIED"
    """
    Unspecified usage is allowed in calls which identify the resource by other fields and do not need Usage set to complete. These are i.e.: GetInternalRange and DeleteInternalRange. Usage needs to be specified explicitly in CreateInternalRange or UpdateInternalRange calls.
    """
    FOR_VPC = "FOR_VPC"
    """
    A GCP resource can use the reserved CIDR block by associating it with the Internal Range resource if usage is set to FOR_VPC.
    """
    EXTERNAL_TO_VPC = "EXTERNAL_TO_VPC"
    """
    Ranges created with EXTERNAL_TO_VPC cannot be associated with GCP resources and are meant to block out address ranges for various use cases, like for example, usage on-prem, with dynamic route announcements via interconnect.
    """
